/*
This is source for a dll that, when used in combination with Microsoft
Research's Detours Package (a binary rewriting package for Windows 2000 et. al),
will lie to the program it is attached to about the current time on the machine.
It is currently unfinished & untested, because I don't have access to Win2k. I
intend to use it to elucidate information about various timestamps embedded in
CHM files, and also to eliminate the effect of those timestamps on other parts
of the CHM format (eg compression), by making those timestamps constant.

Public Domain by Pabs <pabs3@zip.to>
Please let me know if you get it to work.
*/


#include <stdio.h>
#include <windows.h>
#include "detours.h"

#pragma warning(disable:4100)   // Trampolines don't use formal parameters.

DETOUR_TRAMPOLINE(VOID WINAPI Real_GetSystemTime(LPSYSTEMTIME lpSystemTime), GetSystemTime);
DETOUR_TRAMPOLINE(VOID WINAPI Real_GetLocalTime(LPSYSTEMTIME lpSystemTime), GetLocalTime);
DETOUR_TRAMPOLINE(VOID WINAPI Real_GetSystemTimeAsFileTime(LPFILETIME lpSystemTimeAsFileTime), GetSystemTimeAsFileTime);
DETOUR_TRAMPOLINE(BOOL WINAPI Real_GetFileTime(HANDLE hFile, LPFILETIME lpCreationTime, LPFILETIME lpLastAccessTime, LPFILETIME lpLastWriteTime), GetFileTime );
DETOUR_TRAMPOLINE(DWORD WINAPI Real_GetTickCount(VOID), GetTickCount);
DETOUR_TRAMPOLINE(DWORD WINAPI Real_GetTimeZoneInformation(LPTIME_ZONE_INFORMATION lpTimeZoneInformation), GetTimeZoneInformation);

#define declare(type,name) type _##name; type Inc_##name;
declare(SYSTEMTIME,GetSystemTime)
declare(SYSTEMTIME,GetLocalTime)
declare(FILETIME,GetSystemTimeAsFileTime)
declare(FILETIME,GetFileTime[3])
declare(DWORD,GetTickCount)
declare(TIME_ZONE_INFORMATION,GetTimeZoneInformation)

#define Read_(type) \
VOID Read_##type(HANDLE h, type* in){ \
	DWORD dummy; \
	ReadFile( h, in, sizeof(*in), &dummy, NULL ); \
}
Read_(SYSTEMTIME)
Read_(FILETIME)
Read_(DWORD)
Read_(TIME_ZONE_INFORMATION)

#define Write_(type) \
VOID Write_##type(HANDLE h, type* in){ \
	DWORD dummy; \
	WriteFile( h, in, sizeof(*in), &dummy, NULL ); \
}
Write_(SYSTEMTIME)
Write_(FILETIME)
Write_(DWORD)
Write_(TIME_ZONE_INFORMATION)

VOID WINAPI Evil_GetSystemTime(LPSYSTEMTIME st){
	*st = _GetSystemTime;
	
}

VOID WINAPI Evil_GetLocalTime(LPSYSTEMTIME st){
	st->wYear = 0;
	st->wMonth = 0;
	st->wDayOfWeek = 0;
	st->wDay = 0;
	st->wHour = 0;
	st->wMinute = 0;
	st->wSecond = 0;
	st->wMilliseconds = 0;
}

VOID WINAPI Evil_GetSystemTimeAsFileTime(LPFILETIME ft){
	ft->dwLowDateTime = 0;
	ft->dwHighDateTime = 0;
}

BOOL WINAPI Evil_GetFileTime(HANDLE h, LPFILETIME c, LPFILETIME a, LPFILETIME w){
	c->dwLowDateTime = 0;
	c->dwHighDateTime = 0;
	a->dwLowDateTime = 0;
	a->dwHighDateTime = 0;
	w->dwLowDateTime = 0;
	w->dwHighDateTime = 0;
	return TRUE;
}

DWORD WINAPI Evil_GetTickCount(VOID){
	return 0;
}

DWORD WINAPI Evil_GetTimeZoneInformation(LPTIME_ZONE_INFORMATION tzi){
	ZeroMemory(tzi,sizeof(*tzi));
    return TRUE;
}

BOOL WINAPI DllMain(HINSTANCE hinst, DWORD dwReason, LPVOID reserved)
{
	if (dwReason == DLL_PROCESS_ATTACH) {
		printf("evil-time.dll: Starting evil time functions.\n");
		fflush(stdout);
	
		HANDLE f;
#define _read_(type,name) \
		f = CreateFile( #name, GENERIC_READ, 0, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL); \
		if( f ){ \
			Read_##type( f, &_##name ); \
			CloseHandle( f ); \
		} \
		f = CreateFile( "Inc_" #name , GENERIC_READ, 0, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL); \
		if( f ){ \
			Read_##type( f, &Inc_##name ); \
			CloseHandle( f ); \
		}

		_read_(SYSTEMTIME,GetSystemTime)
		_read_(SYSTEMTIME,GetLocalTime)
		_read_(FILETIME,GetSystemTimeAsFileTime)
		_read_(FILETIME,GetFileTime[0])
		_read_(FILETIME,GetFileTime[1])
		_read_(FILETIME,GetFileTime[2])
		_read_(DWORD,GetTickCount)
		_read_(TIME_ZONE_INFORMATION,GetTimeZoneInformation)

#define detour(a) DetourFunctionWithTrampoline((PBYTE)Real_##a, (PBYTE)Evil_##a)
 		detour(GetSystemTime);
		detour(GetLocalTime);
		detour(GetSystemTimeAsFileTime);
		detour(GetFileTime);
		detour(GetTickCount);
		detour(GetTimeZoneInformation);
	} else if (dwReason == DLL_PROCESS_DETACH) {
#define remov(a) DetourRemove((PBYTE)Real_##a, (PBYTE)Evil_##a)
 		remov(GetSystemTime);
		remov(GetLocalTime);
		remov(GetSystemTimeAsFileTime);
		remov(GetFileTime);
		remov(GetTickCount);
		remov(GetTimeZoneInformation);
		
		HANDLE f;
#define _write_(type,name) \
		f = CreateFile( #name, GENERIC_WRITE, 0, NULL, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL); \
		if( f ){ \
			Write_##type( f, &_##name ); \
			CloseHandle( f ); \
		} \
		f = CreateFile( "Inc_" #name , GENERIC_WRITE, 0, NULL, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL); \
		if( f ){ \
			Write_##type( f, &Inc_##name ); \
			CloseHandle( f ); \
		}

		_write_(SYSTEMTIME,GetSystemTime)
		_write_(SYSTEMTIME,GetLocalTime)
		_write_(FILETIME,GetSystemTimeAsFileTime)
		_write_(FILETIME,GetFileTime[0])
		_write_(FILETIME,GetFileTime[1])
		_write_(FILETIME,GetFileTime[2])
		_write_(DWORD,GetTickCount)
		_write_(TIME_ZONE_INFORMATION,GetTimeZoneInformation)
		
		printf("evil-time.dll: Removed evil time functions.\n");
		fflush(stdout);
	}
	return TRUE;
}

VOID NullExport(){}